HDU 1142 A Walk Through the Forest(最短路+记忆化搜索)

A Walk Through the Forest

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 10172    Accepted Submission(s): 3701

Problem Description

Jimmy experiences a lot of stress at work these days, especially since his accident made working difficult. To relax after a hard day, he likes to walk home. To make things even nicer, his office is on one side of a forest, and his house is on the other. A nice walk through the forest, seeing the birds and chipmunks is quite enjoyable.
The forest is beautiful, and Jimmy wants to take a different route everyday. He also wants to get home before dark, so he always takes a path to make progress towards his house. He considers taking a path from A to B to be progress if there exists a route from B to his home that is shorter than any possible route from A. Calculate how many different routes through the forest Jimmy might take.

Input

Input contains several test cases followed by a line containing 0. Jimmy has numbered each intersection or joining of paths starting with 1. His office is numbered 1, and his house is numbered 2. The first line of each test case gives the number of intersections N, 1 < N ≤ 1000, and the number of paths M. The following M lines each contain a pair of intersections a b and an integer distance 1 ≤ d ≤ 1000000 indicating a path of length d between intersection a and a different intersection b. Jimmy may walk a path any direction he chooses. There is at most one path between any pair of intersections.

Output

For each test case, output a single integer indicating the number of different routes through the forest. You may assume that this number does not exceed 2147483647

Sample Input

5 6
1 3 2
1 4 2
3 4 3
1 5 12
4 2 34
5 2 24
7 8
1 3 1
1 4 1
3 7 1
7 4 1
7 5 1
6 7 1
5 2 1
6 2 1
0

Sample Output

2
4

Source

University of Waterloo Local Contest 2005.09.24

Recommend

Eddy   |   We have carefully selected several similar problems for you:  1217 1385 1548 1596 2112

题目意思:

这道题不是求最短路的条数!!!

注意了

题目是说如果A到终点的距离大于B到终点的距离,那么我们认为A到B是满足条件的路径

问你满足条件的路的条数

分析:

先用终点做起点然后求单源最短路,得到每个点到终点的距离

然后通过记忆化搜索,搜满足条件的路径数目!!!

主要是题目意思难懂,很容易误解成为求1到2的最短路条数

code:

#include<iostream>
#include<stdio.h>
#include<memory.h>
using namespace std;
#define max_v 1005
#define INF 9999999
int n,m;
int vis[max_v];
int dis[max_v];
int e[max_v][max_v];
int dp[max_v];
void init()
{
    memset(vis,0,sizeof(vis));
    for(int i=0;i<=n;i++)
    {
        for(int j=0;j<=n;j++)
        {
            e[i][j]=INF;
        }
        dp[i]=-1;
        dis[i]=INF;
    }
}
void Dijkstra(int s)
{
    for(int i=1;i<=n;i++)
        dis[i]=e[s][i];
    dis[s]=0;
    for(int i=1;i<=n;i++)
    {
        int index,mindis=INF;
        for(int j=1;j<=n;j++)
        {
            if(!vis[j]&&dis[j]<mindis)
            {
                mindis=dis[j];
                index=j;
            }
        }
        vis[index]=1;
        for(int j=1;j<=n;j++)
            if(dis[index]+e[index][j]<dis[j])
                dis[j]=dis[index]+e[index][j];
    }
}
int dfs(int v)
{
    if(dp[v]!=-1)
        return dp[v];
    if(v==2)
        return 1;
    int sum=0;
    for(int i=1;i<=n;i++)
        if(dis[v]>dis[i]&&e[v][i]!=INF)
             sum+=dfs(i);
    dp[v]=sum;
    return dp[v];
}
int main()
{
    while(~scanf("%d",&n))
    {
        if(!n)
            break;
        scanf("%d",&m);
        init();
        for(int i=0;i<m;i++)
        {
            int x,y,z;
            scanf("%d %d %d",&x,&y,&z);
            if(e[x][y]>z)
                e[x][y]=e[y][x]=z;
        }
        Dijkstra(2);
        printf("%d\n",dfs(1));
    }
    return 0;
}

原文地址:https://www.cnblogs.com/yinbiao/p/9451042.html

时间: 2024-11-02 00:51:01

HDU 1142 A Walk Through the Forest(最短路+记忆化搜索)的相关文章

hdu 1142 A Walk Through the Forest (Dijkstra + 记忆化搜索)

A Walk Through the Forest Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 5984    Accepted Submission(s): 2211 Problem Description Jimmy experiences a lot of stress at work these days, especial

hdu 1142 A Walk Through the Forest (最短路+dfs )

A Walk Through the Forest Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 5809    Accepted Submission(s): 2147 Problem Description Jimmy experiences a lot of stress at work these days, especial

HDU - 1142 A Walk Through the Forest (最短路)

A Walk Through the Forest Jimmy experiences a lot of stress at work these days, especially since his accident made working difficult. To relax after a hard day, he likes to walk home. To make things even nicer, his office is on one side of a forest,

HDU 1142 A Walk Through the Forest(dijkstra+记忆化DFS)

题意: 给你一个图,找最短路.但是有个非一般的的条件:如果a,b之间有路,且你选择要走这条路,那么必须保证a到终点的所有路都小于b到终点的一条路.问满足这样的路径条数 有多少,噶呜~~题意是搜了解题报告才明白的Orz....英语渣~ 思路: 1.1为起点,2为终点,因为要走ab路时,必须保证那个条件,所以从终点开始使用单源最短路Dijkstra算法,得到每个点到终点的最短路,保存在dis[]数组中. 2.然后从起点开始深搜每条路,看看满足题意的路径有多少条. 3.这样搜索之后,dp[1]就是从起

HDU 1142 A Walk Through the Forest (Dijkstra + 记忆化搜索 好题)

A Walk Through the Forest Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6350    Accepted Submission(s): 2332 Problem Description Jimmy experiences a lot of stress at work these days, especial

HDU 1142 A Walk Through the Forest (记忆化搜索+Dijkstra算法)

A Walk Through the Forest Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 7583    Accepted Submission(s): 2791 Problem Description Jimmy experiences a lot of stress at work these days, especial

题解报告:hdu 1142 A Walk Through the Forest

题目链接:acm.hdu.edu.cn/showproblem.php?pid=1142 Problem Description Jimmy experiences a lot of stress at work these days, especially since his accident made working difficult. To relax after a hard day, he likes to walk home. To make things even nicer,

hdu 1142 A Walk Through the Forest (digkstra+记忆化搜索)

A Walk Through the Forest Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 7322    Accepted Submission(s): 2685 Problem Description Jimmy experiences a lot of stress at work these days, especial

HDU - 1142 A Walk Through the Forest(Dijkstra+DFS)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1142 题意:从1到达2,路径要尽可能短(就先一遍dijkstra),并且要求每次距离2的路径要比上一个点距离2的路径近,求有多少符合条件的线路. 以2为起始点先进行一遍dijkstra,然后再从1开始dfs,寻找符合条件的线路(就是可以搜到2的线路). #include <bits/stdc++.h> using namespace std; const int INF=0x3f3f3f3f; c